﻿Public Class ClassAverageForm
   ' handles Add Grade Button's Click event
   Private Sub addButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles addButton.Click

      ' clear previous grades and calculation result
      If averageResultLabel.Text <> "" Then
         averageResultLabel.Text = ""
         gradesListBox.Items.Clear()
      End If

      ' display grade in ListBox
      gradesListBox.Items.Add(Val(gradeTextBox.Text))
      gradeTextBox.Clear() ' clear grade from TextBox
      gradeTextBox.Focus() ' transfer focus to TextBox

      ' prohibit users from entering more than 10 grades
      If gradesListBox.Items.Count >= 10 Then
         addButton.Enabled = False ' disable Add Grade Button
         averageButton.Focus() ' transfer focus to Average Button
      End If
   End Sub ' addButton_Click

   ' handles Average Button's Click event
   Private Sub averageButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles averageButton.Click

      ' initialization phase
      Dim total As Integer = 0
      Dim gradeCounter As Integer = 0
      Dim grade As Integer = 0
      Dim average As Double = 0

      ' sum grades in ListBox
      Do
         ' read grade from ListBox
         grade = gradesListBox.Items.Item(gradeCounter)
         total += grade ' add grade to total
         gradeCounter += 1 ' increment counter
      Loop Until gradeCounter >= 10

      average = total / 10 ' calculate average
      averageResultLabel.Text = String.Format("{0:F}", average)
      addButton.Enabled = True ' enable Add Grade Button
      gradeTextBox.Focus() ' reset focus to Enter grade: TextBox
   End Sub ' averageButton_Click
End Class ' ClassAverageForm

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************